VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3555
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7605
   LinkTopic       =   "Form1"
   ScaleHeight     =   3555
   ScaleWidth      =   7605
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFields 
      Height          =   1695
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   7
      Text            =   "Form1.frx":0000
      Top             =   1800
      Width           =   4815
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Height          =   375
      Left            =   1800
      TabIndex        =   6
      Top             =   1080
      Width           =   735
   End
   Begin VB.TextBox txtTableTo 
      Height          =   285
      Left            =   960
      TabIndex        =   5
      Text            =   "Contacts2"
      Top             =   720
      Width           =   3615
   End
   Begin VB.TextBox txtTableFrom 
      Height          =   285
      Left            =   960
      TabIndex        =   3
      Text            =   "Contacts1"
      Top             =   360
      Width           =   3615
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Top             =   0
      Width           =   3615
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Field Mapping (Source -> Destination):"
      Height          =   195
      Index           =   3
      Left            =   0
      TabIndex        =   8
      Top             =   1560
      Width           =   2700
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "To Table"
      Height          =   195
      Index           =   2
      Left            =   0
      TabIndex        =   4
      Top             =   720
      Width           =   645
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "From Table"
      Height          =   195
      Index           =   1
      Left            =   0
      TabIndex        =   2
      Top             =   360
      Width           =   795
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Database"
      Height          =   195
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   690
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCopy_Click()
Dim db As DAO.Database
Dim rs_fr As DAO.Recordset
Dim rs_to As DAO.Recordset
Dim mappings() As String
Dim mapping_line() As String
Dim name_fr As String
Dim name_to As String
Dim fields_fr() As DAO.Field
Dim fields_to() As DAO.Field
Dim field_fr As DAO.Field
Dim field_to As DAO.Field
Dim num_fields As Integer
Dim line_num As Integer
Dim i As Integer
Dim num_copied As Long

    ' Open the database.
    Set db = DBEngine.Workspaces(0).OpenDatabase(txtDatabase.Text, ReadOnly:=False)

    ' This example empties the "to" table before starting.
    ' You may or may not want this in a real application.
    db.Execute "DELETE FROM " & txtTableTo.Text

    ' Open the tables.
    Set rs_fr = db.OpenRecordset(txtTableFrom.Text, dbOpenTable)
    Set rs_to = db.OpenRecordset(txtTableTo.Text, dbOpenTable)

    ' Get the field mappings.
    num_fields = 0
    mappings = Split(txtFields.Text, vbCrLf)
    For line_num = LBound(mappings) To UBound(mappings)
        mapping_line = Split(mappings(line_num), "->")
        ' Make sure we have exactly 2 entries.
        If UBound(mapping_line) - LBound(mapping_line) <> 1 Then
            name_fr = ""
            name_to = ""
        Else
            ' Get the field names.
            name_fr = Trim$(mapping_line(LBound(mapping_line)))
            name_to = Trim$(mapping_line(UBound(mapping_line)))
        End If

        ' Make sure we have two field names.
        If Len(name_fr) > 0 And Len(name_to) > 0 Then
            ' Get the corresponding field objects.
            On Error Resume Next
            Set field_fr = rs_fr.Fields(name_fr)
            If Err.Number <> 0 Then Set field_fr = Nothing
            Set field_to = rs_to.Fields(name_to)
            If Err.Number <> 0 Then Set field_to = Nothing
            Err.Clear
            On Error GoTo 0
        End If

        ' If the field objects are not Nothing, then save them.
        If Not ((field_fr Is Nothing) Or (field_to Is Nothing)) Then
            num_fields = num_fields + 1
            ReDim Preserve fields_fr(1 To num_fields)
            ReDim Preserve fields_to(1 To num_fields)
            Set fields_fr(num_fields) = field_fr
            Set fields_to(num_fields) = field_to
        End If
    Next line_num

    ' Copy the records.
    num_copied = 0
    Do Until rs_fr.EOF
        ' Make a new record.
        rs_to.AddNew

        ' Copy the field values.
        For i = 1 To num_fields
            fields_to(i).Value = fields_fr(i).Value
        Next i
        rs_to.Update

        rs_fr.MoveNext
        num_copied = num_copied + 1
    Loop

    rs_fr.Close
    rs_to.Close
    db.Close

    MsgBox "Copied " & num_copied & " records"
End Sub
Private Sub Form_Load()
Dim db_path As String

    db_path = App.Path
    If Right$(db_path, 1) <> "\" Then db_path = db_path & "\"
    txtDatabase.Text = db_path & "People.mdb"
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - txtDatabase.Left
    If wid < 120 Then wid = 120
    txtDatabase.Width = wid
    txtTableFrom.Width = wid
    txtTableTo.Width = wid

    cmdCopy.Left = (ScaleWidth - cmdCopy.Width) / 2

    hgt = ScaleHeight - txtFields.Top
    If hgt < 120 Then hgt = 120
    txtFields.Move 0, txtFields.Top, ScaleWidth, hgt
End Sub


